!-----------------------------------------------------------------------
      module Database_class
! bring Personnel_class into scope
      use Personnel_class
      private :: init_Database, print_Database
! define Database type
      type Database
         private
         class (Personnel), pointer :: file
         type (Database), pointer :: next
      end type Database
      interface new
         module procedure init_Database
      end interface
      interface print
         module procedure print_Database
      end interface
      contains
         subroutine init_Database(this)
! Constructor
         type (Database), intent (out) :: this
! nullify pointers
         nullify(this%file)
         nullify(this%next)
         end subroutine init_Database
!
         subroutine print_Database(this)
! Print the database
         type (Database), target, intent (inout) :: this
         type (Database), pointer :: tmp
         tmp => this
         do while (associated(tmp%next))
            call tmp%file%print()
            tmp => tmp%next
         enddo
         end subroutine print_Database
!
         subroutine add(this,f)
! Add a file to the database
         type (Database), target, intent (inout) :: this
         class (Personnel), pointer :: f
         type (Database), pointer :: tmp
         tmp => this
         do while (associated(tmp%next))
            tmp => tmp%next
         enddo
         tmp%file => f
         allocate(tmp%next)
         call new(tmp%next)
         end subroutine add
!
         subroutine remove(this,s)
! Remove a file from the database
         type (Database), target, intent (inout) :: this
         integer, intent (in) :: s
         type (Database), pointer :: tmp
         tmp => this
         do while (associated(tmp%next))
            if (tmp%file%getssn()==s) then
               tmp%file => tmp%next%file
               tmp%next => tmp%next%next
               return
            endif
            tmp => tmp%next
         enddo
         Print *,'Database::remove: file not found'
         end subroutine remove
!
         function locate(this,s)
! Find a file in the database
         type (Database), target, intent (in) :: this
         integer, intent (in) :: s
         type (Database), pointer :: tmp
         class (Personnel), pointer :: locate
         tmp => this
         do while (associated(tmp%next))
            if (tmp%file%getssn()==s) then
               locate => tmp%file
               return
            endif
            tmp => tmp%next
         enddo
         Print *,'Database::locate: file not found'
         nullify(locate)
         end function locate
      end module Database_class
