!-----------------------------------------------------------------------
      module Personnel_class
      implicit none
      private :: init_Personnel, term_Personnel, print_Personnel
      private :: getssn_Personnel
! Define Personnel type
      type Personnel
         private
         integer :: ssn
         character, dimension(:), pointer :: firstname, lastname
      contains
         procedure :: delete => term_Personnel
         procedure :: print => print_Personnel
         procedure :: getssn => getssn_Personnel
      end type Personnel
! Number of database records
      integer, save, private :: NUM_FILES = 0
      interface new
         module procedure init_Personnel
      end interface
      contains
         subroutine init_Personnel(this,s,fn,ln)
! Constructor
         type (Personnel), intent (out) :: this
         integer, intent (in) :: s
         character(len=*), intent (in) :: fn, ln
         this%ssn = s
         allocate(this%firstname(len(fn)),this%lastname(len(ln)))
         call strcpy(this%firstname,fn)
         call strcpy(this%lastname,ln)
         NUM_FILES = NUM_FILES + 1
         end subroutine init_Personnel
!
         subroutine term_Personnel(this)
! Destructor
         class (Personnel), intent (inout) :: this
         deallocate(this%firstname,this%lastname)
         NUM_FILES = NUM_FILES - 1
         end subroutine term_Personnel
!
         subroutine print_Personnel(this,printssn)
         class (Personnel), intent (in) :: this
         logical, optional, intent (in) :: printssn
         if (present(printssn)) then
            if (printssn) write (*,'(i2,a2)',advance='no') this%ssn,': '
         endif
         Print *, this%firstname, ' ', this%lastname
         end subroutine print_Personnel
!
         function getssn_Personnel(this) result(ssn)
         class (Personnel), intent (in) :: this
         integer :: ssn
         ssn = this%ssn
         end function getssn_Personnel
!
         integer function get_num_files()
         get_num_files = NUM_FILES
         end function get_num_files
!
         subroutine strcpy(s,c)
         character, dimension (:), intent (out) :: s
         character(len=*), intent (in) :: c
         integer :: i
         do i = 1, max(size(s),len(c))
            s(i) = c(i:i)
         enddo
         end subroutine strcpy
      end module Personnel_class
