!-----------------------------------------------------------------------
      module Student_class
! bring Personnel_class into scope
      use Personnel_class
      implicit none
      private :: Personnel, init_Student, term_Student, print_Student
! define String type
      type, private :: String
         character(len=1), dimension(:), pointer :: stringptr
      end type String
! define Student type
      type, extends(Personnel) :: Student
         private
         integer :: nclasses
         type (String), dimension (10) :: classes
      contains
         procedure :: delete => term_Student
         procedure :: print => print_Student
      end type Student
      interface new
         module procedure init_Student
      end interface
      contains
         subroutine init_Student(this,s,fn,ln)
! Student class constructor
         type (Student), intent (out) :: this
         integer, intent (in) :: s
         character(len=*), intent (in) :: fn, ln
         call new(this%personnel,s,fn,ln)
         this%nclasses = 0
         end subroutine init_Student
!
         subroutine term_Student(this)
! Student class destructor
         class (Student), intent (inout) :: this
         integer :: i
         call this%personnel%delete()
         do i = 1, this%nclasses
            deallocate(this%classes(i)%stringptr)
         enddo
         end subroutine term_Student
!
         subroutine print_Student(this,printssn)
! Print a student file
         class (Student), intent (in) :: this
         logical, optional, intent (in) :: printssn
         integer :: i, j
         call this%personnel%print(printssn)
         if (this%nclasses==0) then
            Print *,'-- Not Enrolled'
         else
            Print *,'-- Enrolled:'
            do i = 1, this%nclasses
             do j = 1, size(this%classes(i)%stringptr)
               write (*,'(a)',advance='no') this%classes(i)%stringptr(j)
             enddo
             Print *
            enddo
         endif
         end subroutine print_Student
!
         subroutine addclass(this,c)
! Add a class to a student file
         class (Student), intent (inout) :: this
         character(len=*), intent (in) :: c
         this%nclasses = this%nclasses + 1
         allocate(this%classes(this%nclasses)%stringptr(len(c)))
         call strcpy(this%classes(this%nclasses)%stringptr,c)
         end subroutine addclass
      end module Student_class
